<template>
  <box :loading="loading">
    <template v-slot:title>{{ capitalizeFirstLetter(action) }} User</template>

    <div class="px-3 w-full">
      <lull-input
        label="Email:"
        :class="[hasError('email') && 'shake']"
        :message="getValidationMessage('email')"
        :status="getValidationStatus('email')"
        v-model="user.email"
      />

      <div class="pt-5 flex flex-row">
        <lull-input
          class="w-5/12 pr-5"
          label="Fist Name:"
          :class="[hasError('firstName') && 'shake']"
          :message="getValidationMessage('firstName')"
          :status="getValidationStatus('firstName')"
          v-model="user.firstName"
        />

        <lull-input
          class="w-5/12"
          label="Last Name:"
          :class="[hasError('lastName') && 'shake']"
          :message="getValidationMessage('lastName')"
          :status="getValidationStatus('lastName')"
          v-model="user.lastName"
        />

        <div class="w-2/12 flex flex-col flex-grow-0 items-center">
          <label>Enabled:</label>
          <lull-switch
            name="Enabled"
            v-model="user.enabled"
            :disabled="action === ManageAction.Create"
          />
        </div>
      </div>

      <div class="pt-5 w-full">
        <lull-select
          label="Roles"
          optionsLabel="name"
          class="w-5/12 pr-5"
          :multiple="true"
          :options="roles"
          v-model="user.roles"
        />
      </div>
    </div>

    <template v-slot:footer>
      <div class="flex flex-row justify-end px-3 pt-3 pr-6 pb-6">
        <lull-button type="danger" class="w-28" @click="$router.push('/users')">
          Cancel
        </lull-button>
        <lull-button type="info" class="ml-3 w-28" @click="save()">
          Save
        </lull-button>
      </div>
    </template>
  </box>
</template>

<script lang="ts">
import {
  computed,
  ComputedRef,
  defineComponent,
  onBeforeMount,
  onBeforeUnmount,
  reactive,
} from 'vue';
import { capitalizeFirstLetter } from '@/core/helpers/util';
import { ManageAction } from '@/core/types/ManageAction';
import { User as UserModel } from '@/core/models/user';
import { required, email } from '@vuelidate/validators';
import useValidation from '@/core/composables/useValidations';
import { useStore } from '@/store';
import { useRoute, useRouter } from 'vue-router';
import { UserAction, UserModule, UserMutation } from '@/store/Users';
import { useLullToast } from 'lull-ui';

export default defineComponent({
  name: 'user',
  props: {
    action: { type: String, required: true, default: ManageAction.Create },
  },
  setup(props) {
    const user: Partial<UserModel> = reactive({
      enabled: true,
    });
    const store = useStore();
    const router = useRouter();
    const route = useRoute();
    const toast = useLullToast();
    const roles = computed(() => store.getters['user/roles']);
    const loading: ComputedRef<boolean> = computed(
      () => store.getters['user/loading']
    );
    const rules = {
      email: { required, email },
      firstName: { required },
      lastName: { required },
    };

    const { validation, getValidationMessage, getValidationStatus, hasError } =
      useValidation(rules, user);

    async function save(): Promise<void> {
      validation.value.$touch();
      if (validation.value.$invalid) {
        return;
      }

      const mutation =
        props.action === ManageAction.Create
          ? UserAction.CreateUser
          : UserAction.UpdateUser;

      const response = await store.dispatch(`user/${mutation}`, {
        user: user,
        roles: user.roles,
      });

      if (response) {
        toast?.success({
          title: 'Success',
          message: `User ${props.action}ed.`,
        });
        router.push('/users');

        return;
      }

      toast?.error({
        title: 'Error',
        message: 'Something went wrong. Try again?',
      });
    }

    async function setup(): Promise<void> {
      if (props.action === ManageAction.Edit) {
        const results = await store.dispatch(
          `user/${UserAction.GetUser}`,
          route.params.id
        );

        Object.assign(user, results);
      }

      await store.dispatch(`user/${UserAction.GetRoles}`);
      store.commit(`user/${UserMutation.SetLoading}`, false);
    }

    onBeforeMount(async () => {
      await store.registerModule('user', UserModule);
      await setup();
    });

    onBeforeUnmount(async () => {
      await store.unregisterModule('user');
    });

    return {
      capitalizeFirstLetter,
      user,
      loading,
      getValidationMessage,
      getValidationStatus,
      hasError,
      save,
      ManageAction,
      roles,
    };
  },
});
</script>

<style lang="scss" scoped>
</style>